package chap10.program07

object CombinatorParserTest2 {
  def main(args: Array[String]) : Unit = {
    test("Test1: ", "1 + 2")
    test("Test2: ", "1 - 2")
    test("Test3: ", "8")
    test("Test4: ", "1 * 2")
  }

  def test(caption: String, data: String) {
    print(caption + data)
    val result = new CombinatorParser2().parse(data)
    if (result.successful)
      println(" ==> " + eval(result.get))
    else
      println(" ==> " + result)
  }

  def eval(ir:IR2): Double = ir match {
    case Operator("+", opr1, opr2) => eval(opr1) + eval(opr2)
    case Operator("-", opr1, opr2) => eval(opr1) - eval(opr2)
    case Number(n) => n
  }
}
