package chap06.program06

class ColorError {
  val sky = "sky"
  def printColor(input: String) {
    input match {
      // パターン変数(定数名が小文字から始まる):
      // 以下コメントアウトを外すとコンパイルエラーが発生する
      //case sky => println("blue")
      case ambiguous => println(ambiguous + " is unknown!")
    }
  }
}

object Example7 {
  def main(args: Array[String]) {
    new ColorError().printColor("sky")
    new ColorError().printColor("car")
  }
}
